'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _fullScreen = require('./fullScreen');

var _fullScreen2 = _interopRequireDefault(_fullScreen);

var _fullscreenModule = require('./fullscreen.module.css');

var _fullscreenModule2 = _interopRequireDefault(_fullscreenModule);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /** Libraries **/


/** Function **/


// css


var FullScreen = function (_PureComponent) {
  _inherits(FullScreen, _PureComponent);

  function FullScreen(props) {
    _classCallCheck(this, FullScreen);

    var _this = _possibleConstructorReturn(this, (FullScreen.__proto__ || Object.getPrototypeOf(FullScreen)).call(this, props));

    _this.onFullScreen = _this.onFullScreen.bind(_this);
    _this.onFullScreenChange = _this.onFullScreenChange.bind(_this);
    _this.onExit = _this.onExit.bind(_this);

    _this.fscreenRef = _react2.default.createRef();
    return _this;
  }

  _createClass(FullScreen, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      _fullScreen2.default.addEventListener('fullscreenchange', this.onFullScreenChange);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var isfscreenElement = _fullScreen2.default.fullscreenElement === this.fscreenRef.current;
      if (isfscreenElement && !this.props.isEnabled) {
        this.onExit();
      } else if (!isfscreenElement && this.props.isEnabled) {
        this.onFullScreen();
      }
    }
  }, {
    key: 'onFullScreen',
    value: function onFullScreen() {
      _fullScreen2.default.isFullscreenEnabled && _fullScreen2.default.requestFullscreen(this.fscreenRef.current);
    }
  }, {
    key: 'onExit',
    value: function onExit() {
      _fullScreen2.default.isFullscreenEnabled && _fullScreen2.default.exitFullscreen();
    }
  }, {
    key: 'onFullScreenChange',
    value: function onFullScreenChange() {
      var onChange = this.props.onChange;

      onChange && onChange(_fullScreen2.default.fullscreenElement === this.fscreenRef.current);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _fullScreen2.default.removeEventListener('fullscreenchange', this.onFullScreenChange);
      this.fscreenRef = null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          isEnabled = _props.isEnabled,
          className = _props.className,
          children = _props.children;

      if (isEnabled) {
        className += ' fullscreenEnabled';
      }
      return _react2.default.createElement(
        'div',
        { className: className + ' ' + _fullscreenModule2.default.fullScreen, ref: this.fscreenRef },
        children
      );
    }
  }]);

  return FullScreen;
}(_react.PureComponent);

exports.default = FullScreen;


FullScreen.defaultProps = {
  isEnabled: false,
  className: ''
};

FullScreen.propTypes = {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  isEnabled: _propTypes2.default.bool.isRequired,
  onChange: _propTypes2.default.func
};